<?php

##########################################################
############ ---===> INITIALIZE STUFF <===--- ############
##########################################################

unset($rssfile);

##########################################################
################ ---===> SETTINGS <===--- ################
##########################################################

$title            = 'easyNews';
$description      = 'easyNews - more then only news';
$homeurl          = 'http://localhost';
$newslink         = $homeurl . '/index.php?action=show&amp;id=$newsid';
$commentslink     = $homeurl . '/index.php?action=comments&amp;id=$newsid';
$rss_minchars     = 500; // minimum chars displayed, before the newstext gets shortened (0 = show complete text)
$rss_displaychars = 400; // length, to what the newstest gets shortened
$language         = 'de-de';
$ttl              = 60; // time in minutes the rss-file should be loaded from the readers cache
$webmastername    = 'easyNews Webmaster';
$webmasteremail   = 'email@domain.tld';
$newsfile         = $en_paths['newsfile'];
$savepath         = './rss/news.xml';
$entrys           = 10;

##########################################################
################ ---===> THE CORE <===--- ################
##########################################################

###################### CREATE HEADER #####################

$xmlversion = '<' . '?xml version="1.0" encoding="ISO-8859-1"?' . '>';
$lastbuilddate = date('r');
$rssfile = <<<HEADER
$xmlversion
<rss version="2.0">
	<channel>
		<title>$title</title>
		<link>$homeurl</link>
		<description>$description</description>
		<webMaster>$webmasteremail ($webmastername)</webMaster>
		<lastBuildDate>$lastbuilddate</lastBuildDate>
		<docs>http://blogs.law.harvard.edu/tech/rss</docs>
		<generator>easyNews $en_version</generator>
		<language>$language</language>
		<ttl>$ttl</ttl>
HEADER;

###################### CREATE ITEMS ######################

if (strstr($_SERVER['PHP_SELF'], 'rss.php')) die('Please don't call the script directly');
$newsdata = file($newsfile);
$linen = sizeof($newsdata);

if ($linen) {
	if ($linen < $entrys) $entrys = $linen;
	for ($i = 0; $i < $entrys; $i++) {
		$news = en_getdata(chop($newsdata[$i]), $en_newsscheme);
		$newsid = $linen - $i;
		eval ('$link = "' . addslashes($newslink) . '";');
		$link = stripslashes($link);
		$news['email'] = $news['email'] != '' ? $news['email'] : 'email@not.set';
		$news['title'] = str_replace('&komma;', ',', $news['title']);

		if (preg_match('#^([012][0-9]|3[01])\.(0[0-9]|1[012])\.(19[789][0-9]|20([012][0-9]|3[0-7]))$#', trim($news['date']), $datematches)
		/* matches from 1.1.1970 to 31.12.2037, though it matches things, like 31.02.2003, too */
		AND preg_match('#^([01][0-9]|2[0-3]):([0-5][0-9])$#', trim($news['time']), $timematches)) {
		/* matches valid times, btw: Friedl rox ;) */
		    list($void, $day, $mon, $year) = $datematches;
		    list($void, $hour, $min) = $timematches;
			$timestamp = mktime((int)$hour, (int)$min, 0, (int)$mon, (int)$day, (int)$year);
			
			$pubdate = '
			<pubDate>' . date('r', $timestamp) . '</pubDate>';
		} else {
			$pubdate = '';
		}
		
		// build description (possibly shortened newstext)
		// patterns to replace [url]-Tags with plaintext-links
		$patterns = array (
			'#\[url=(&quot;|"|\'|)(.+)\\1](.+)\[/url\]#Uis',
			'#\[url\](.+)\[/url\]#Uis'
		);
		
		// the necessary replacements
		$replacements = array (
			'\\3 (\\2)',
			'\\1'
		);

		// replace linebreaks and <br />-tags with spaces
		$news['text'] = preg_replace('#((&lt;|<)br\s*/?(>|&gt;)|\n)#i', ' ', $news['text']);
		$news['text'] = preg_replace($patterns, $replacements, $news['text']);

		// do some formatting
		$news['text'] = str_replace('&komma;', ',', $news['text']);
		$news['text'] = bbcode($news['text']);

		// strip all remaining tags
		$news['text'] = en_strip_tags($news['text']);
		if ($rss_minchars > 0 AND strlen($news['text']) > $rss_minchars) {
			$news['text'] = preg_replace('#\s+[^\s]*$#i', ' ...', substr($news['text'], 0, $rss_displaychars));
		}
		$news['text'] = htmlspecialchars($news['text']);
		$news['text'] = chop($news['text']);

		if ($en_settings['addcomments'] == 'yes') {
			eval ('$comments = "' . addslashes($commentslink) . '";');
			$comments = '
			<comments>' . $comments . '</comments>';
		} else {
			$comments = '';
		}
		$rssfile .= <<<ITEMS

		<item>
			<title><![CDATA[$news[title]]]></title>
			<description><![CDATA[$news[text]]]></description>
			<link>$link</link>
			<author>$news[email] ($news[author])</author>$pubdate$comments
		</item>
ITEMS;
	}
}

###################### CREATE FOOTER #####################

$rssfile .= <<<FOOTER

	</channel>
</rss>
FOOTER;

save($savepath, $rssfile);

?>
